/* IBM_PROLOG_BEGIN_TAG                                                   */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Program 5724-K69                                                       */
/*                                                                        */
/* COPYRIGHT International Business Machines Corp. 2004,2009              */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with                */
/* IBM Corp.                                                              */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */

// ABOUT:
// This overload (One of a pair) demonstrates chaining multiple overloads
// together.

// wire.h contains the SVN OpenGL enumerants (e.g. GLCOLOR3F etc.) and must be included
#include "wire.h"

static void(*s_glColor3f)(float,float,float);
static void o_1_glColor3f(float,float,float);

void Overload(glOp *glOperationsTable, glOp *glSystemOperationsTable)
{
    // save a pointer to the 'true' system glColor3f() call:
    s_glColor3f = (void(*)(float,float,float)) glOperationsTable [GLCOLOR3F];

    // Overload the set of OpenGL functions seen by the application with.
    // our custom glColor3f call instead
    glOperationsTable[GLCOLOR3F] = (glOp)o_1_glColor3f;
}

static void
o_1_glColor3f(float r, float g, float b)
{
    // Change all color calls to be just RED
    float modified_r = 1;
    float modified_g = 0;
    float modified_b = 0;

    // Call the 'true' glColor3f OpenGL function with modified values.
    (*s_glColor3f)(modified_r,modified_g,modified_b);
}

